--[[
	GuildShield by Janniie - Stormreaver EU
	
	The purpose of GuildShield is to protect players from being
	contacted by guild invite mods. 
	
	To users: Use this as any other AddOn and you will be protected against some
	          guild invite mods.
			  
	To developers: 1. Put GuildShield.lua in you Guild Invite AddOns' folder and load it before your own, ie in the TOC file.
				   
				   2. Then run the function GuildShield:Initiate(action) inside your AddOn.
				   
				   "action" is the function you wish to call when you find a player with GuildShield
				   active.
				   
				   In my case it's a function that removes the player from my AddOns' invite queue.
				   
				   3. Then call, when fitting, GuildShield:IsShielded(playerName) to check if the player
				      has GuildShield installed. If they have, the "action" you specified earlier should be called
				      automaically, and in my case remove the player.
]]



GuildShield = {}
RegisterAddonMessagePrefix("GUILD_SHIELD")
RegisterAddonMessagePrefix("I_HAVE_SHIELD")

local function IsShielded(self,player)
	SendAddonMessage("GUILD_SHIELD","","WHISPER",player)
end

local function Initiate(self,action)
	local Shield = CreateFrame("Frame")
	Shield:RegisterEvent("CHAT_MSG_ADDON")
	Shield:SetScript("OnEvent",function(self,event,...)
		local prefix,msg,channel,sender = select(1,...)
		if prefix == "I_HAVE_SHIELD" then
			action(sender)
		end
	end)
	print("|cffffff00Guild|r|cff00A2FFShield|r|cff55EE55 has been initiated|r")
end

GuildShield.IsShielded = IsShielded
GuildShield.Initiate = Initiate

do
	local f = CreateFrame("Frame")
	f:RegisterEvent("CHAT_MSG_ADDON")
	f:SetScript("OnEvent",function(self,event,...)
		local prefix,msg,channel,sender = select(1,...)
		if prefix == "GUILD_SHIELD" and sender ~= UnitName("player") then
			SendAddonMessage("I_HAVE_SHIELD","","WHISPER",sender)
		end
	end)
	print("|cffffff00Guild|r|cff00A2FFShield|r|cff55EE55 is active and protecting you|r")
end